--[[ Chace ]]
--[[ Decoy ]]
--[[ Engage ]]
--[[ Guard ]]
--[[ Support ]]
--[[ My ]]
local BehaviorAI = {}


---------------------


--[[ Public ]]
function ifBehavior()
	BehaviorAI.Run()
end

--[[ Public ]]
function ifCommand(Cmd, ActorID)
	BehaviorAI.Command(Cmd, ActorID)
end

--[[ Public ]]
function ifChangeState(State)
	BehaviorAI.ChangeState(State)
end

--[[ Public ]]
function ifTarget(ActorID)
	BehaviorAI.Target(ActorID)
end


---------------------


--[[ Private ]]
function BehaviorAI.Run()
	local Cmd = My.Command
	
	BehaviorAI.Command(Cmd)
end

--[[ Private ]]
function BehaviorAI.Command(Cmd, ActorID)
	local TargetID = 0
	
	if 		Cmd == CMD_STAYALART then
		BehaviorAI.StayAlart()
		
	elseif Cmd == CMD_ENGAGE then
		BehaviorAI.Engage()
		
	elseif Cmd == CMD_STEALTH then
		BehaviorAI.Stealth()
		
	elseif Cmd == CMD_DECOY then
		BehaviorAI.Decoy()
		
	elseif Cmd == CMD_SEARCH then
		BehaviorAI.Search()
		
	elseif Cmd == CMD_SUPPORT then
		if IsTrue(ActorID) then
			TargetID = ActorID
		else
			TargetID = My.Support
		end
		BehaviorAI.Support(TargetID)
		
	elseif Cmd == CMD_GUARD then
		if IsTrue(ActorID) then
			TargetID = ActorID
		else
			TargetID = My.Guard
		end
		BehaviorAI.Guard(TargetID)
		
	elseif Cmd == CMD_CHASE then
		if IsTrue(ActorID) then
			TargetID = ActorID
		elseif IsTrue(My.Chase) then
			TargetID = My.Chase
		else
			TargetID = My.Owner.ID
		end
		BehaviorAI.Chase(TargetID)
		
	end
end


---------------------


--[[ Private ]]
function BehaviorAI.ChangeState(State)
	Trace("AI State  : " .. My.State .. "  " .. State)
	My.State = State
end

--[[ Private ]]
function BehaviorAI.StayAlart()
	BehaviorAI.ChangeState(ST_WAIT)
end

--[[ Private ]]
function BehaviorAI.Engage()
	ifEngage()
end

--[[ Private ]]
function BehaviorAI.Stealth()
	ifStealth()
end

--[[ Private ]]
function BehaviorAI.Decoy()
	ifDecoy()
end

--[[ Private ]]
function BehaviorAI.Support(ActorID)
	My.Support = ActorID
	ifSupport()
end

--[[ Private ]]
function BehaviorAI.Guard(ActorID)
	My.Guard	= ActorID
	ifGuard()
end

--[[ Private ]]
function BehaviorAI.Chase(ActorID)
	My.Chase	= ActorID
	ifChase()
end

--[[ Private ]]
function BehaviorAI.Search()
	ifSearch()
end

--[[ Private ]]
function BehaviorAI.Target(ActorID)
	Trace("Target  " .. ActorID)
	My.Target	= ActorID
end


