--[[ ExceptDataAccesser ]]
--[[ PlayerDataAccesser ]]
--[[ Party ]]
--[[ My ]]
--[[ Position ]]
Ask = {}


--[[ Public ]]
function IsString(val)
	if type(val) == "string" then
		return true
	else
		return false
	end
end

--[[ Public ]]
function IsNumber(val)
	if type(val) == "number" then
		return true
	else
		return false
	end
end

--[[ Public ]]
function IsBoolean(val)
	if type(val) == "boolean" then
		return true
	else
		return false
	end
end

--[[ Public ]]
function IsNil(val)
	if val == nil then
		return true
	else
		return false
	end
end

--[[ Public ]]
function IsTrue(val)
	if val==nil or val==0 or val=="" or val=="H" then
		return false
	else
		return true
	end
end

--[[ Public ]]
function IsTable(val)
	if type(val) == "table" then
		return true
	else
		return false
	end
end

--[[ Public ]]
function IsFunction(val)
	if type(val) == "function" then
		return true
	else
		return false
	end
end


---------------------


--[[ Public ]]
function IsSkillMotion(ActorID)
	if GetV(V_MOTION,ActorID) == MOTION_SKILL then
		return true
	else
		return false
	end
end

--[[ Public ]]
function IsInSight(TargetID)
	local Dist = Position.GetDistanceFromMe(TargetID)
	if 0<Dist and Dist<20 then
		return true
	else
		return false
	end
end
	
--[[ Public ]]
function IsInFightRange(TargetID)
	local Dist = Position.GetDistanceFromMe (TargetID)
	if Dist == -1 then
		return false
	end
	
	local Range = GetV (V_ATTACKRANGE, ActorID)
	if Dist <= Range then
		return true
	else
		return false
	end
end

--[[ Public ]]
function IsInSkillRange(TargetID, SkillID)
	local Dist = Position.GetDistanceFromMe(TargetID)
	if Dist == -1 then
		return false
	end
	
	local Range = GetV (V_SKILLATTACKRANGE, My.ID, SkillID)
	if Dist <= Range then
		return true
	else
		return false
	end
end

--[[ Public ]]
function IsOutOfSight (ActorID, TargetID)
	local ActPos = { X=0, Y=0 }
	local TgtPos = { X=0, Y=0 }
	
	ActPos.X, ActPos.Y	= Positoin.GetPosition(ActorID)
	TgtPos.X, TgtPos.Y		= Position.GetPosition(TargetID)
	
	if (ActPos.X == -1 or TgtPos.X == -1) then
		return true
	end
	
	local Dist = Position.GetDistance(ActPos, TgtPos)
	if 20 < Dist then
		return true
	else
		return false
	end
end

--[[ Public ]]
function IsInAttackSight (ActorID, TargetID)	
	local Dist	= Position.GetDistance (ActorID, TargetID)
	if Dist == -1 then
		return false
	end
	
	local Range= 0
	if (My.Skill == 0) then
		Range = GetV (V_ATTACKRANGE, ActorID)
	else
		Range = GetV (V_SKILLATTACKRANGE, ActorID, My.Skill)
	end

	if Dist<=Range then
		return true
	else
		return false
	end
end
