My = {}


--[[ Public Parameter ]]
My.ID				= 0
My.HomType		= 0
My.Character		= {}

My.Pos				= { X=0, Y=0 }
My.PrevPos		= { X=0, Y=0 }
My.OwnerDistance			= 0
My.PrevOwnerDistance	= 0

My.State			= ST_WAIT
My.Command		= CMD_STAYALART
My.Target			= 0
My.Chase			= 0
My.Guard			= 0
My.Support		= 0

My.Skill				= 0
My.SkillLevel		= 0
My.Delay			= 0
My.UsingSkill		= List.New()

My.CmdList		= List.New()
My.ResCmdList	= List.New()

My.Owner			= {}
My.Status			= {}
My.PriorityList	= {}

My.ClearedToEngage		= false
My.SearchStateEnable	= true
My.AIEnable		= true


-----------------


function My.Initialize(myid)
	Trace("My Initialize", "Start")
	
	My.ID			= myid
	My.HomType	= GetV(V_HOMUNTYPE, myid)
	My.Status		= MY_STATUS
	My.Character = HomCharacter.GetCharacter(MY_CHARACTER)
	
	if My.Character.BaseCommand==CMD_ENGAGE then
		My.ClearedToEngage = true
	end
	
	My.Chase		= My.Owner.ID
	My.Support	= My.Owner.ID
	My.Guard		= My.Owner.ID
	
	-- Owner̃Xe[^Xi[Ă邪AȂׂFinding.luaGetActorDatag
	My.Owner.ID			= GetV(V_OWNER, myid)
	My.Owner.Status	= OWNER_STATUS
	
	Trace("MyOwner.ID: " .. My.Owner.ID , "", TRACE_PARAM)
	Trace("MyID	: " .. myid , "", TRACE_PARAM)
	Trace("Chara	: " .. My.Character.Name , "", TRACE_PARAM)
	
	Trace("My Initialize", "End")
end

function My.Update()
	Trace("My Update")
	My.PrevPos.X			= My.Pos.X
	My.PrevPos.Y 		= My.Pos.Y
	
	My.Pos.X, My.Pos.Y	= Position.GetPosition(My.ID)

	My.PrevOwnerDistance	= My.OwnerDistance
	My.OwnerDistance			= Position.GetDistanceFromOwner(My.ID)
end

--[[ Public ]]
function My.IsWait()
	if My.State==ST_WAIT then
		return true
	else
		return false
	end
end

--[[ Public ]]
function My.IsMoving()
	if My.State==ST_MOVE then
		return true
	else
		return false
	end
end

--[[ Public ]]
function My.IsAttacking()
	if My.State==ST_ATACK then
		return true
	else
		return false
	end
end

--[[ Public ]]
function My.IsDead()
	if My.State==ST_DEAD then
		return true
	else
		return false
	end
end


--[[ Public ]]
function My.GetHPPercent()
	local Rate = (My.GetNowHP() / My.GetMaxHP()) * 100 
	return Rate
end

--[[ Public ]]
function My.GetSPPercent()
	local NowSP	= GetV (V_SP, My.ID) 
	local MaxSP	= GetV (V_MAXSP, My.ID) 
	local Rate		= (NowSP / MaxSP) * 100 
	return Rate
end

--[[ Public ]]
function My.GetMaxHP()
	return GetV (V_MAXHP, My.ID) 
end

--[[ Public ]]
function My.GetHP()
	return GetV (V_HP, My.ID) 
end

--[[ Public ]]
function My.GetMaxSP()
	return GetV (V_MAXSP, My.ID) 
end

--[[ Public ]]
function My.GetSP()
	return GetV (V_SP, My.ID) 
end

--[[ Public ]]
function My.IsDelay()
	if TICK_TIME < My.Delay then
		return true
	else
		return false
	end
end

--[[ Public ]]
function My.SetDelay( TickTime )
	My.Delay = TICK_TIME + TickTime
end
